﻿# -*- coding: utf-8 -*-

###########################################################################
## File:        data.py
## Description: This file includes all global variables not related to the records
###########################################################################

configFolder="/home/user/.SleepAnalyser/" #users home dir with ending /
homedir="/home/user/"
defaultRecordFolder="/home/user/MyDocs/SleepAnalyser/" #users record dir with ending /
ConfigFile="SleepAnalyser.conf"
PresetNamesFile="Presetnames.conf"

developmentconfigFolder="/home/gruinelli/Entwicklung/Maemo/GARAGE_SVN/Sleepanalyser/" #development PC
developmentRecordFolder="/home/gruinelli/Entwicklung/Maemo/GARAGE_SVN/Sleepanalyser/data/" #development PC

SongFolder="/home/user/MyDocs/.sounds"

AccSensorPath="/sys/class/i2c-adapter/i2c-3/3-001d/coord"

dateformat="%Y-%m-%d %H:%M:%S" #the date/time is stored in this format in the record files

song_file_types="*.mp3 *.ogg *.wav"

LogFile="/home/user/MyDocs/SleepAnalyser/SleepAnalyser.log" #Place for log file. IF YOU CHANGE THIS PATH, YOU ALSO HAVE TO CHANGE IT IN /usr/bin/sleepanalyser!

translation_copyrights="English, German: George Ruinelli\n"+\
                                     (u'Français')+": Fred Kwame Ayanful & Guy Roussin\n"+\
                                     "Dutch: Fred Kwame Ayanful\n"+\
                                     "Chinese: "+(u'蒋岚')+" (Peter3316)"

#DEFAULT VALUES
Yscale_Movement_default=20  #Y stretching of yellow movement bars
DelayStartTime_default=10 #Default recording start delay
Yscale_Sleep_Pattern_default=40 #Y stretching of blue sleep pattern
Yoffset_Sleep_Pattern_default= 0  #Y offset of blue sleep pattern

Light_Sleep_Level_default=70
Deep_Sleep_Level_default=35

configFileVersion=5 #increase if parameters have changed


GraphBitMap=""
GraphBitMapLen=0
GraphBitMapHeight=0

StatisticsBitMap=""
StatisticsBitMapLen=110
StatisticsBitMapHeight=65

DisplayIsOn=True
ScrollToEnd=False


Sampling_interval=1000 #in milliseconds
Sample_index=0
Sample_smoothing=10 #value_smoothing at 1. level
Value_smoothing=10 #value_smoothing at 2. level
Derivation=5 #shift in Derivation

Ysize=121 #default value Y scale in px




DelayStartTime=0
Yscale_Movement=0 #Y stretching of yellow movement bars
Yscale_Sleep_Pattern=0  #Y stretching of blue sleep pattern
Yoffset_Sleep_Pattern= 0 #Y offset of blue sleep pattern

arrXscale=[1, 4, 6] #scaling steps X accis
arrXscaleLen=3
Xscale=1 #default value X scale in arraXscale index

derivation_offset=2


#Value_index=0
#Values_total=0

arrRecordFiles=[]
arrRecordFilesIndex=0

Trigger=14 #Trigger level for movement
maxTrigger=120
minTrigger = 1

Light_Sleep_Level=0
Deep_Sleep_Level=0

demo=0
debug=False

RecordFilename=""
RecordFile=""
RecordFolder=""
LastRecord=""

#ChangesInGraph=False
run=False
QuickMode=False
version=0
build=0

LastWindow=""

user=""
app_path="./"
preset_names=["", "", "", ""]

last_beep=0


SwitchedModes=False
OfflineMode=False
PreviousMode="normal"
SilentProfile=False
DimmDisplay=False
PreviousBrightness=5
RecordingBrightness=0
PreviousProfile="silent"
PreviousVolume=50


language="" #2-letter country code

UIStyle=""

DelayStart=0
interval=0

AlarmHour=7
AlarmMinute=0
UseAlarm=False
AlarmIsActive=False
AlarmTimeWindow=30 #in minutes
AlarmID=-1 #cookie for communication to system

StopAfterAlarm=True

Status=""
Progress=""

#arrays, indexes, lenghts
#             [0]=time            [1]=X, [2]=Y, [3]=X+Y Derivation, [4]=Time since last movement over treshhold, [5]=event
arrDataTemp=[0, 0, 0] #[0]=X, [1]=Y, [2]=Z
arrDataIndex=0
arrRecordFiles=[]
arrRecordFilesIndex=0
RecordFileSelectedDate=""


#Graph colors
MovementBarColor="#DFAD09" #"Yellow"
GraphBackground="#000000"
GraphBackground2="#2B2B2B"

#Colors for time bars
Deep_Sleep_Color=       "#00C800" #green
Deep_Sleep_ColorDark="#003200"
#Light_Sleep_Color=        "#006400" #darker green
#Light_Sleep_ColorDark= "#001400"
Light_Sleep_Color=        "#D87519" #darker green
Light_Sleep_ColorDark= "#3D370A"
Awake_Color=                "#860000" #red
Awake_ColorDark=         "#4C0000"

Lucid_Dream_Color=      "#00C800" #"#B3FF8F"
WakeUp_Color=             "red" #"#FEA2FF"


#noiseReduction=4  #Smoothing of derivation data


limitMovement=250


Animation=0


Use_Lucid_Dream_Song=False
Lucid_Dream_Song=""
Lucid_Dream_Song_Volume=30
Lucid_Dream_Song_Delay=600
Lucid_Dream_Song_Duration = 0
Lucid_Dream_SongIsActive=False

Use_WakeUp_Song=False
WakeUp_Song=""
WakeUp_Song_Volume=50
WakeUp_Song_Duration=0
WakeUp_SongIsActive=False

UseAlternativeAlarm=False
AlternativeAlarm=""

cliStart=""
cliStop=""

CurrentVolume=5 #start value for wake up music
WakeUp_Song_Volume_Increase_Step=4 #increase step time in pro mille (0.1%)
